<?php
/**
 *.Hack Name:        Shop Hack
 * Version:          3.4
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

if (!defined('IN_CODE')) {
    header('HTTP/1.0 403 Forbidden');
    exit("Not allowed to run this file directly.");
}

require ROOT.'include/shop.inc.php';
assertEmptyOutputStream('shop.inc.php');

// Copyrights - these are called by all Shop pages
$versioncomp    = 'The XMB Group';
$vershort       = 'XMB Shop';
$vergeneral     = 'The XMB Shop Hack v3.4';
$scopyright     = '2006-2012';

if ( $show_full_info || X_SADMIN ) {
    $latebuild  = '20120217';
    $entirever  = 'Powered by '.$vergeneral;
} else {
    $latebuild  = '[HIDDEN]';
    $entirever  = 'Powered by '.$vershort;
}

$footerads = '<a href="shop_info.php?action=info">'.$entirever.'</a><br />Developed by '.$versioncomp.' &copy; '.$scopyright;

$tables[] = 'member_items';
$tables[] = 'shop_bank';
$tables[] = 'shop_cats';
$tables[] = 'shop_items';
$tables[] = 'shop_settings';
$tables[] = 'shop_votes';

// Create global Shop variable
$shopsetquery = $db->query("SELECT * FROM ".X_PREFIX."shop_settings");
foreach ($db->fetch_array($shopsetquery) as $key => $val) {
    $SHOP[$key] = $val;
}
$db->free_result($shopsetquery);
$currency = $SHOP['currencyname']; //for display purposes only
$shopname = $SHOP['shopname']; //for display purposes only

/* Shop Hack v2.1 - Bank and Interest */
$bank_lastdate = explode('|', $SHOP['bank_lastdate']);
$bank_yearnow = gmdate("Y", time() + ($SETTINGS['addtime'] * 3600));
$bank_monnow  = gmdate("m", time() + ($SETTINGS['addtime'] * 3600));
$bank_mdaynow = gmdate("j", time() + ($SETTINGS['addtime'] * 3600));
$bank_hournow = gmdate("H", time() + ($SETTINGS['addtime'] * 3600));

if ( $bank_lastdate['2'] < $bank_yearnow || $bank_lastdate['1'] < $bank_monnow || $bank_lastdate['0'] < $bank_mdaynow ) {
    // Fake transaction-style isolation using table locks.  iid = -1 for next run time, iid = -2 for thread status.
    $proceed = FALSE;
    if ( $SHOP['bank_hour'] == $bank_hournow ) {
        $query = $db->query("SELECT quantity FROM ".X_PREFIX."member_items WHERE uid = 0 AND iid = -1");
        if (0 == $db->num_rows($query)) {
            $proceed = TRUE;
        } else {
            $row = $db->fetch_array($query);
            if ((int)$row['quantity'] < time() or (int)$row['quantity'] > time() + 86400) {
                $proceed = TRUE;
            }
        }
        $db->free_result($query);
    }
    if ($proceed) {
        // The bank token is tentatively valid or missing.
        $newtoken = time() + 300;
        $db->query("LOCK TABLES ".X_PREFIX."member_items WRITE");
        $query = $db->query("SELECT quantity FROM ".X_PREFIX."member_items WHERE uid = 0 AND iid = -1");
        if (0 == $db->num_rows($query)) {
            $db->query("INSERT INTO ".X_PREFIX."member_items SET uid = 0, iid = -1, quantity = $newtoken");
        } else {
            $row = $db->fetch_array($query);
            if ((int)$row['quantity'] < time() or (int)$row['quantity'] > time() + 86400) {
                $db->free_result($query);
                $query = $db->query("SELECT quantity FROM ".X_PREFIX."member_items WHERE uid = 0 AND iid = -2");
                if (0 != $db->num_rows($query)) {
                    // A previous attempt was interrupted.  Assume it was already successful and do not repeat it the same day.
                    $row = $db->fetch_array($query);
                    if ($row['quantity'] == $bank_mdaynow) {
                        $proceed = FALSE;
                        $newtoken = time() + 3600;
                        $db->query("UPDATE ".X_PREFIX."member_items SET quantity = $newtoken WHERE uid = 0 AND iid = -1");
                    }
                    $db->query("DELETE FROM ".X_PREFIX."member_items WHERE uid = 0 AND iid = -2");
                }
                if ($proceed) {
                    $db->query("UPDATE ".X_PREFIX."member_items SET quantity = $newtoken WHERE uid = 0 AND iid = -1");
                }
            } else {
                $proceed = FALSE;
            }
        }
        $db->free_result($query);
        $db->query("UNLOCK TABLES");
    }
    if ($proceed) {
        // The bank token exists and is valid for this thread.  Save an in-progress checknum
        $db->query("INSERT INTO ".X_PREFIX."member_items SET uid = 0, iid = -2, quantity = $bank_mdaynow");

        // Calculate interest for all members who have a non-zero balance.
        $coeff = (100 + $SHOP['bank_interest']) / 100;
        $db->query("UPDATE ".X_PREFIX."members SET bank_balance = bank_balance * $coeff");

        // Record the date.
        $bank_lastdate = "$bank_mdaynow|$bank_monnow|$bank_yearnow";
        $db->query("UPDATE ".X_PREFIX."shop_settings SET bank_lastdate='$bank_lastdate'");
        $db->query("DELETE FROM ".X_PREFIX."member_items WHERE uid = 0 AND iid = -2");
    }
}

?>
