<?php
/**
 *.Hack Name:        Shop Hack
 * Version:          3.4
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

if (!defined('IN_CODE')) {
    header('HTTP/1.0 403 Forbidden');
    exit("Not allowed to run this file directly.");
}

function assertShopTranslation() {
    global $lang, $langfile;

    if (isset($lang['shop_textshoprules'])) { // code duplicated in shop.php
        return TRUE;
    } elseif (installShopTranslation($langfile)) {
        loadLang($langfile);
        return TRUE;
    } else {
        exit ('Error: XMB Shop failed to start because the default language is missing.  Please place English.shop.php in the lang subfolder to correct this.');
    }
}

function installShopTranslation($loadname='', $savename='') {
    global $langfile;

    require_once(ROOT.'include/translation.inc.php');

    if ($loadname == '') {
        $loadname = $langfile;
    }
    if ($savename == '') {
        $savename = $loadname;
    }

    // Load a shop language file
    if (file_exists(ROOT.'lang/'.$loadname.'.shop.php')) {
        require ROOT.'lang/'.$loadname.'.shop.php';
    } elseif (file_exists(ROOT.'lang/English.shop.php')) {
        require ROOT.'lang/English.shop.php';
    } else {
        return FALSE;
    }

    setManyLangValues($lang, $savename);

    // Shop language is now installed but is not loaded.
    return TRUE;
}

?>
