<?php
/**
 *.Hack Name:        Shop Hack
 * Version:          3.4
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 **/

define('X_SCRIPT', 'install.php');

// Get required files
if (!defined('ROOT')) define('ROOT', '../');
error_reporting(-1); // Report all errors until config.php loads successfully.

if ( !is_file('../include/shop.inc.php') ) {
    exit('Missing file: /include/shop.inc.php');
}
require (ROOT.'header.php');
require (ROOT.'include/shop.inc.php');

loadtemplates('misc_feature_notavailable');

// Define Navigation
nav('XMB Shop Hack v3');

define('X_INST_ERR',    0);
define('X_INST_WARN',   1);
define('X_INST_OK',     2);
define('X_INST_SKIP',   3);
define('Shop_Version_Field', '3.4');

function error_inst($head, $msg, $die=true) {
    echo "\n";
    echo '<div class="progressErrorDiv">';
    echo '<span class="progressErr">'.$head.'</span><br />';
    echo '<span class="progressWarn">'.$msg.'</span>';
    echo '</div>';
    echo "\n";
    if ( $die) {
        exit;
    }
}

function show_act($act) {
    $act .= str_repeat('.', (75-strlen($act)));
    echo '<span class="progress">'.$act.'</span>';
}

function show_result($type) {
    switch($type) {
        case 0:
            echo '<span class="progressErr">ERROR</span><br />';
            break;

        case 1:
            echo '<span class="progressWarn">WARNING</span><br />';
            break;

         case 2:
            echo '<span class="progressOk">OK</span><br />';
            break;

         case 3:
            echo '<span class="progressSkip">SKIPPED</span><br />';
            break;
    }
    echo "\n";
}

function rmFromDir($path) {
    if (is_dir($path)) {
        $stream = opendir($path);
        while(($file = readdir($stream)) !== false) {
            if ($file == '.' || $file == '..') {
                continue;
            }
            rmFromDir($path.'/'.$file);
        }
        closedir($stream);
        @rmdir($path);
    } else if (is_file($path)) {
        @unlink($path);
    }
}

// Add some temporary installer CSS
$cssInclude .= <<< EOF
<style type="text/css">
    .progressErr {
        color: #FF0000;
    }

    .progressWarn {
        color: #FF9900;
    }

    .progressOk {
        color: #009900;
    }

    .progressSkip {
        color: #0000FF;
    }

    .progress {
        font-family: Courier New, monospace;
        font-size: 12px;
    }

    .progressErrorDiv {
        margin-top: 5px;
        margin-left: 15px;
        margin-bottom: 5px;
    }
</style>
EOF;

eval('$css = "'.template('css').'";');
eval('echo "'.template('header').'";');

if (!X_SADMIN) {
    eval('echo "'.template('error_nologinsession').'";');
    end_time();
    eval('echo "'.template('footer').'";');
    exit();
}

$action = ( (isset($_GET['action']) && !empty($_GET['action'])) ? $_GET['action'] : '');
?>
<table cellspacing="0" cellpadding="0" width="<?php echo $THEME['tablewidth']?>" align="center">
<tr>
<td bgcolor="<?php echo $THEME['bordercolor']?>">
<table cellspacing="<?php echo $THEME['borderwidth']?>" cellpadding="<?php echo $THEME['tablespace']?>" width="100%">
<tr>
<td class="category" colspan="2"><font color="<?php echo $THEME['cattext']?>"><strong>XMB Shop Hack v<?php echo Shop_Version_Field; ?> Installation</strong></font></td>
</tr>
<tr>
<td bgcolor="<?php echo $THEME['altbg2']?>" class="tablerow" colspan="2">
<?php
if($action == "check") {
    echo'<font class="progress">Checking for required shop components</font><br /><br />';
    $req['files'] = array('./lang/English.shop.php', './include/shop.inc.php', './shop.php', './shop_bank.php', './shop_cp.php',
                          './shop_edit.php', './shop_info.php', './shop_item.php', './install/shop.xmb');

    $req['tables']   = array('member_items', 'shop_bank', 'shop_cats', 'shop_items', 'shop_settings', 'shop_votes');
    $chk['members']  = array('money', 'bank_balance', 'glowcolor', 'hexcolor', 'pphoto', 'shopavloc', 'glowcolormem', 'hexcolormem', 'pphotomem', 'allowitems');

        show_act('Checking Required Files');
        foreach ($req['files'] as $file) {
            if (!file_exists(ROOT.$file)) {
                show_result(X_INST_ERR);
                error_inst('Missing File', 'XMB could not locate the file <em>/'.$file.'</em>, this file is required for Shop to work properly. Please upload this file and restart installation.', true);
                exit();
            }
        }
        show_result(X_INST_OK);

    // Check for database tables
    if ( count($req['tables']) > 0 ) {
        echo '<br /><br />Checking for old Shop Installs<br /><br />';
        foreach($req['tables'] as $table){
            show_act('Checking for existing '.$tablepre.$table);
            if (in_array($tablepre.$table, $db->fetch_tables($dbname))) {
                show_result(X_INST_ERR);
                error_inst('Existing Shop Hack found', 'An existing installation of shop hack has been detected in the "'.$dbname.'" database.<br />If you wish to overwrite this installation, please run the shop uninstaller or upgrade.', true);
            }
            show_result(X_INST_OK);
        }
    }

    // Check for certain fields in certain database tables
    if ( count($chk) > 0 ) {
        foreach($chk as $table=>$fieldarray){
            echo '<br /><br />Checking for modifications in the `'.$tablepre.$table.'` table<br />';
            foreach($fieldarray as $key=>$field){
                show_act('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Checking for: `'.$field.'`');
                $field_exists = mysql_query("SELECT `$field` FROM `".$tablepre.$table."`");
                if ( $field_exists )  {
                    show_result(X_INST_WARN);
                    error_inst('Existing installation found', 'An existing field has been detected in the "'.$tablepre.$table.'" table.<br />If you wish to overwrite this installation, please run the uninstaller or upgrade.', false);
                } else {
                    show_result(X_INST_OK);
                }
            }
        }
    }
    ?>
    <br /><br />
    If all above show as "OK" you are ready to perform the Shop hack installation. <br /><br />
    You can do this by clicking "Proceed" below.
    </td>
    </tr>
    <tr>
    <td align="left" class="tablerow" bgcolor="<?php echo $THEME['altbg2']?>" width="50%"><a href="./install/install.php">&laquo; Go Back</a></td>
    <td align="right" class="tablerow" bgcolor="<?php echo $THEME['altbg2']?>" width="50%"><a href="./install/install.php?action=install">Proceed &raquo;</a></td>
    </tr>
    <?php
} elseif ($action == 'install') {
    echo 'Please wait...the installation process is starting...<br />This process may take a few minutes...<br /><br />';

    show_act('Creating '.$tablepre.'member_items table');
    $db->query("DROP TABLE IF EXISTS ".$tablepre."member_items");
    $db->query("CREATE TABLE ".$tablepre."member_items (
        iid smallint(6) NOT NULL default '0',
        uid int(12) NOT NULL default '0',
        quantity int(10) NOT NULL default '0',
        PRIMARY KEY (iid, uid),
        INDEX (uid)
    ) TYPE=MyISAM
    ");
    show_result(X_INST_OK);

    show_act('Creating '.$tablepre.'shop_bank table');
    $db->query("DROP TABLE IF EXISTS ".$tablepre."shop_bank");
    $db->query("CREATE TABLE ".$tablepre."shop_bank (
        fromuid int(12) NOT NULL default '0',
        touid int(12) NOT NULL default '0',
        dateline int(10) NOT NULL default '0',
        amount int(10) NOT NULL default '0',
        comment text NOT NULL,
        type varchar(10) NOT NULL default '',
        INDEX (fromuid),
        INDEX (touid)
    ) TYPE=MyISAM
    ");
    show_result(X_INST_OK);

    show_act('Creating '.$tablepre.'shop_cats table');
    $db->query("DROP TABLE IF EXISTS ".$tablepre."shop_cats");
    $db->query("CREATE TABLE ".$tablepre."shop_cats (
        id smallint(6) NOT NULL auto_increment,
        cid smallint(6) NOT NULL default '0',
        owner int(12) NOT NULL default '0',
        catname varchar(100) NOT NULL default '',
        description text NOT NULL,
        displayorder int(10) NOT NULL default '0',
        private varchar(30) NOT NULL default '1',
        userlist text NOT NULL,
        lastadd varchar(64) NOT NULL default '',
        password varchar(32) NOT NULL default '',
        status SET('on','off') NOT NULL default 'on',
        creatoronly SET('on','off') NOT NULL default 'off',
        views int(10) NOT NULL default '0',
        items int(10) NOT NULL default '0',
        ownermoney SET('on','off') NOT NULL default 'on',
        PRIMARY KEY (id)
    ) TYPE=MyISAM
    ");
    show_result(X_INST_OK);

    show_act('Inserting data into '.$tablepre.'shop_cats table');
    $db->query("INSERT INTO ".$tablepre."shop_cats VALUES
    ('1', '0', '0', 'Features Store', 'You can buy different abilities here!', '1', '2|1', '|', '', '', 'on', 'no', '0', '7', 'off'),
    ('2', '0', '0', 'Item Store',     'You can buy different items here!', '2', '2|1', '|', '', '', 'on', 'no', '0', '0', 'off'),
    ('3', '0', '0', 'Reseller',       'Resell a previously purchased item.', '3', '2|1', '|', '', '', 'on', 'no', '0', '4', 'off'),
    ('4', '0', '0', 'Member Shops',   'Private Member Shops for your shopping Pleasure!', '4', '3|1', '|', '', '', 'on', 'no', '0', '0', 'off');");
    show_result(X_INST_OK);

    show_act('Creating '.$tablepre.'shop_items table');
    $db->query("DROP TABLE IF EXISTS ".$tablepre."shop_items");
    $db->query("CREATE TABLE ".$tablepre."shop_items (
        id smallint(6) NOT NULL auto_increment,
        cid smallint(6) NOT NULL default '0',
        feature varchar(32) NOT NULL default '',
        owner int(12) NOT NULL default '0',
        itemname varchar(100) NOT NULL default '',
        description text NOT NULL,
        displayorder int(10) NOT NULL default '0',
        imageurl varchar(64) NOT NULL default '',
        dateline int(10) NOT NULL,
        status SET('on','off') NOT NULL default 'on',
        multiple SET('on','off') NOT NULL default 'on',
        sold int(10) NOT NULL default '0',
        rate int(10) NOT NULL default '0',
        votes int(10) NOT NULL default '0',
        comments int(10) NOT NULL default '0',
        price int(10) NOT NULL default '0',
        stock int(10) NOT NULL default '0',
        PRIMARY KEY (id)
    ) TYPE=MyISAM
    ");
    show_result(X_INST_OK);

    show_act('Inserting data into '.$tablepre.'shop_items table');
    $db->query("INSERT INTO ".$tablepre."shop_items VALUES
    ('1',  '1', 'cstatus',          '0', 'Change Custom Status',    'Change your custom status which appears under username in posts.',         '7', '', ".time().", 'on', 'on',  '0', '0', '0', '0', '1000',  '1000'),
    ('2',  '1', 'cusername',        '0', 'Change Username',         'With this action you can change your username.',                           '1', '', ".time().", 'on', 'on',  '0', '0', '0', '0', '10000', '1000'),
    ('3',  '1', 'color',            '0', 'Change Username Colour',  'With this action you can change your username color.',                     '3', '', ".time().", 'on', 'on',  '0', '0', '0', '0', '5000',  '1000'),
    ('5',  '1', 'memshop',          '0', 'Member Shop',             'Buy your own Shop here!',                                                  '8', '', ".time().", 'on', 'off', '0', '0', '0', '0', '1000',  '1000'),
    ('6',  '1', 'pp',               '0', 'Personal Photo',          'Upload your own personal photo which members can view in your profile.',   '4', '', ".time().", 'on', 'on',  '0', '0', '0', '0', '5000',  '1000'),
    ('7',  '1', 'avatar100',        '0', 'Upload Avatar (100*100)', 'Upload your own avatar (Maxsize - 100*100).',                              '5', '', ".time().", 'on', 'on',  '0', '0', '0', '0', '1000',  '1000'),
    ('8',  '1', 'avatar200',        '0', 'Upload Avatar (200*200)', 'Upload your own avatar (Maxsize - 200*200).',                              '6', '', ".time().", 'on', 'on',  '0', '0', '0', '0', '2500',  '1000'),
    ('9',  '3', 'resell_avatar100', '0', 'Avatar (100*100)',        'Delete your avatar from the server.',                                      '4', '', ".time().", 'on', 'on',  '0', '0', '0', '0', '0',     '1000'),
    ('10', '3', 'resell_avatar200', '0', 'Avatar (200*200)',        'Delete your avatar from the server.',                                      '5', '', ".time().", 'on', 'on',  '0', '0', '0', '0', '0',     '1000'),
    ('11', '3', 'resell_pp',        '0', 'Delete Personal Photo',   'Delete your personal photo from the server.',                              '3', '', ".time().", 'on', 'on',  '0', '0', '0', '0', '0',     '1000'),
    ('12', '3', 'resell_color',     '0', 'Change Username Colour',  'With this action you can remove the color from your username.',            '2', '', ".time().", 'on', 'on',  '0', '0', '0', '0', '0',     '1000');");
    show_result(X_INST_OK);

    show_act('Creating '.$tablepre.'shop_settings table');
    $db->query("DROP TABLE IF EXISTS ".$tablepre."shop_settings");
    $db->query("CREATE TABLE ".$tablepre."shop_settings (
    	shop_status SET('on','off') NOT NULL default 'on',
        shoprules SET('on','off') NOT NULL default 'on',
        shoprulestxt text NOT NULL,
        shopname varchar(50) NOT NULL default '',
        currencyname varchar(50) NOT NULL default '',
        AccessCats TEXT NOT NULL,
        AccessShop TEXT NOT NULL,
        userlist text NOT NULL,
        search SET('on','off') NOT NULL default 'on',
        stats SET('on','off') NOT NULL default 'on',
        rating SET('on','off') NOT NULL default 'on',
        subcats SET('on','off') NOT NULL default 'off',
        maxitems int(10) NOT NULL default '50',
        hotcat int(10) NOT NULL default '20',
        hotitem int(10) NOT NULL default '50',
        maxwidth int(10) NOT NULL default '80',
        maxheight int(10) NOT NULL default '80',
        maxsize int(10) NOT NULL default '102400',
        mpr int(10) NOT NULL default '50',
        mpt int(10) NOT NULL default '30',
        mpp int(10) NOT NULL default '20',
        std int(10) NOT NULL default '40',
        spd int(10) NOT NULL default '30',
        imagename int(10) NOT NULL default '0',
        bank SET('on', 'off') NOT NULL default 'on',
        bank_sellitempercent int(3) NOT NULL default '0',
        bank_fee int(3) NOT NULL default '0',
        bank_lastdate varchar(10) NOT NULL default '0|0|0',
        bank_hour decimal(5,2) NOT NULL default '00.00',
        bank_interest int(3) NOT NULL default '2',
        resellerperc INT(3) NOT NULL default '50',
        gdsupport SET('on','off') NOT NULL default 'on',
        memproopt SET('on','off') NOT NULL default 'off',
        rulestime int(10) NOT NULL default '86400',
        shop_ver varchar(10) NOT NULL default '',
        allowitems SET('on','off') NOT NULL default 'on',
        maxwidth_av1 int(5) NOT NULL default '100',
        maxheight_av1 int(5) NOT NULL default '100',
        maxsize_av1 int(10) NOT NULL default '51200',
        maxwidth_av2 int(5) NOT NULL default '200',
        maxheight_av2 int(5) NOT NULL default '200',
        maxsize_av2 int(10) NOT NULL default '81920',
        maxwidth_pp int(5) NOT NULL default '400',
        maxheight_pp int(5) NOT NULL default '300',
        maxsize_pp int(10) NOT NULL default '51200',
        CodeRegs SET('on','off') NOT NULL default 'off',
        CodesTimeRes varchar(12) NOT NULL default '1|#|3600'
    ) TYPE=MyISAM
    ");
    show_result(X_INST_OK);

    show_act('Inserting data into '.$tablepre.'shop_settings table');
    //$db->query("INSERT INTO ".$tablepre."shop_settings (shoprulestxt, shopname, currencyname, AccessCats, AccessShop, shop_ver) VALUES ('Welcome to Shop Hack v2, Developed by the XMB Team. You can edit this message, and more in your Shop CP which is located in your main Admin Panel.', 'Shop', 'XMB Points', '0|FF||AS|Administrator|AS|Super Moderator|AS||DS|Moderator|DS|Member|DS||FF||AU||FF||DU|', '0|FF||AS|Administrator|AS|Super Moderator|AS|Moderator|AS|Member|AS||DS||FF||AU||FF||DU|', '2.0_OmegaB');");

    $db->query("INSERT INTO ".$tablepre."shop_settings
	(`shop_status`, `shoprules`, `shoprulestxt`, `shopname`, `currencyname`, `AccessCats`, `AccessShop`, `userlist`, `search`, `stats`, `rating`, `subcats`, `maxitems`, `hotcat`, `hotitem`, `maxwidth`, `maxheight`, `maxsize`, `mpr`, `mpt`, `mpp`, `std`, `spd`, `imagename`, `bank`, `bank_sellitempercent`, `bank_fee`, `bank_lastdate`, `bank_hour`, `bank_interest`, `resellerperc`, `gdsupport`, `memproopt`, `rulestime`, `shop_ver`, `allowitems`) VALUES
	('on', 'on', 'Welcome to Shop Hack v3! You can edit this message, and more, in your Shop Admin panel which is located in your main Admin Panel.', 'Shop', 'XMB Points', '0|FF||AS|Administrator|AS|Super Moderator|AS||DS|Moderator|DS|Member|DS||FF||AU||FF||DU|', '0|FF||AS|Administrator|AS|Super Moderator|AS|Moderator|AS|Member|AS||DS||FF||AU||FF||DU|', '', 'on', 'on', 'on', 'off', 50, 20, 50, 80, 80, 25600, 50, 30, 20, 40, 30, 2, 'on', 0, 0, '0|0|0', 0, 2, 50, 'on', 'off', 86400, '".Shop_Version_Field."', 'on') ");

    show_result(X_INST_OK);
    show_act('Creating '.$tablepre.'shop_votes table');
    $db->query("DROP TABLE IF EXISTS ".$tablepre."shop_votes");
    $db->query("CREATE TABLE ".$tablepre."shop_votes (
        iid smallint(6) NOT NULL default '0',
        uid int(12) NOT NULL default '0'
    ) TYPE=MyISAM
    ");
    show_result(X_INST_OK);

    show_act('Dropping Duplicate Templates');
    $db->query("DELETE FROM ".$tablepre."templates WHERE name='member_profile_pphoto'");
    $db->query("DELETE FROM ".$tablepre."templates WHERE name LIKE 'shop%'");
    show_result(X_INST_OK);

    show_act('Uploading XMB Shop 2 Templates');
    $templates = explode("|#*XMB TEMPLATE FILE*#|", file_get_contents('shop.xmb'));
    $values = array();
    foreach($templates as $val) {
        $template = explode("|#*XMB TEMPLATE*#|", $val);
        $template[1] = isset($template[1]) ? addslashes(ltrim($template[1])) : '';
        $values[] = "('".$db->escape($template[0])."', '".$db->escape($template[1])."')";
    }
    unset($templates);
    if (count($values) > 0) {
        $values = implode(', ', $values);
        $db->query("INSERT INTO ".$tablepre."templates (name, template) VALUES $values");
    }
    unset($values);
    $db->query("DELETE FROM ".$tablepre."templates WHERE name=''");
    show_result(X_INST_OK);

    show_act('Updating '.$tablepre.'members table');
    $db->query("ALTER TABLE ".$tablepre."members
        ADD money int(10) NOT NULL default '0',
        ADD bank_balance int(10) NOT NULL default '0',
        ADD hexcolorpre varchar(6) NOT NULL default '',
        ADD hexcolor varchar(6) NOT NULL default '',
        ADD pphoto varchar(75) NOT NULL default '',
        ADD shopavloc varchar(20) NOT NULL default '',
        ADD hexcolormem SET('on','off') NOT NULL default 'on',
        ADD pphotomem SET('on','off') NOT NULL default 'on',
        ADD allowitems SET('on','off') NOT NULL default 'on'
    ");
    show_result(X_INST_OK);

    // Remove files
//    $ndf = array(
//        1 => 'shop.xmb',
//        2 => 'install.php'
//        );

    /*if ( count($ndf) > 0 ) {
        show_act('Removing installer files');
        foreach ($ndf as $key => $file) {
            @unlink("./$file");
            if ( !file_exists("./$file") ) {
                unset($ndf[$key]);
            }
        }
        if ( count($ndf) > 0 ) {
            $ndf = '"'.implode('", "', $ndf).'"';
            show_result(X_INST_SKIP);
            error_inst('Permission Error', 'XMB could not remove the '.$ndf.' because of wrong permissions. Please remove them manually via eg. FTP', false);
        } else {
            show_result(X_INST_OK);
        }*/
        show_act('Removing installer files');
        chdir('..');
        rmFromDir('install');
        clearstatcache();
        if (file_exists('./install')) {
            show_result(X_INST_SKIP);
        error('Permission Error', 'XMB could not remove the installer because of wrong permissions. Please remove it manually via eg. FTP', false);
        } else {
            show_result(X_INST_OK);
        }
//    }
?>
<br /><br />
<center><strong><font class="tablerow">XMB Shop Hack has been installed successfully.</font></strong></center><font class="tablerow">
Please refer back to your installation guide to proceed with any remaining steps.<br />
If you have received any errors in this installation or have questions relating to the installation, addons, or any other
shop related item, please visit <a href="http://www.xmbforum.com/">http://www.xmbforum.com/</a>.<br /><br />
Thank you for downloading and installing this hack, we hope you enjoy it.<br />Click the "Finish" link below to exit the installer and return to your forum.</font><br /><br /></td>
</tr>
<tr>
    <td align="left" class="tablerow" bgcolor="<?php echo $THEME['altbg2']?>" width="50%">&nbsp;</td>
    <td align="right" class="tablerow" bgcolor="<?php echo $THEME['altbg2']?>" width="50%"><a href="./">Finish Install &raquo;</a></td>
</tr>
<?php
} else {
?>
    <center><strong>Welcome to XMB's Shop Hack Installation</strong></center><br /><br />
    This hack is designed for universal use and is released under the GPL License. You should have received a copy of
    this license with this modification. If not please contact us at XMBForum.com for a copy of it for your records.
    <br /><br />
    This hack was released exclusively for XMBForum for use on eXtreme Message Boards version 1.9.11.
    If you have an earlier version, please upgrade before proceeding with this hack.
    If you have a later version, please wait until a stable release of this modification comes along for your version.
    <br /><br />
    We strongly suggest backing up all files, templates and databasetables before continuing with this hack.<br />
    <br />
    Before continuing please check if you have previous installations of Shop Hack existing on your forum, or in your
    forum database, by clicking the lower right corner.<br /><br />
    If you need any support on installing this hack please visit:<br />
    <strong><a href="http://forums.xmbforum.com/">XMBForum.com</a></strong> - Your one and only XMB Resource for
    hacks, themes, and conversions.
    </td>
    </tr>
    <tr>
    <td align="left" class="tablerow" bgcolor="<?php echo $THEME['altbg2']?>" width="50%"><a href="./">&laquo; Maybe Later</a></td>
    <td align="right" class="tablerow" bgcolor="<?php echo $THEME['altbg2']?>" width="50%"><a href="./install/install.php?action=check">Check my DB &raquo;</a></td>
    </tr>
    <?php
}
?>
</table>
</td></tr></table>

<?php
end_time();
eval('echo "'.template('footer').'";');

?>
